> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.moveworks.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.moveworks.com/_mcp/server.

# List response messages

GET https://api.moveworks.ai/assistant/v1/conversations/{conversation_id}/responses/{response_id}/messages

Retrieves all messages associated with a specific response (both the user's input message and all assistant reply messages).

Reference: https://help.moveworks.com/api-reference/conversations-api/deprecated-conversations-api/messages/list-response-messages

## Authentication

- `Authorization` header (bearer token, required) — JWT bearer token authentication. Obtain an access token from the Moveworks auth endpoint and include it in the Authorization header as 'Bearer \<token>'.

## Request

### Path parameters

- `conversation_id` (string, required) — A base-62 identifier prefixed by a short resource type
- `response_id` (string, required) — A base-62 identifier prefixed by a short resource type

### Headers

- `Assistant-Name` (string, required) — The Moveworks assistant identifier that was configured for your organization.

## Response

### 200

List of messages for this response

- `messages` (list of object, required) — Array of messages for this response
  - `message_id` (string, required) — A base-62 identifier prefixed by a short resource type
  - `conversation_id` (string, required) — A base-62 identifier prefixed by a short resource type
  - `response_id` (string, required) — A base-62 identifier prefixed by a short resource type
  - `actor` (enum, required) — Message actor type
    - Allowed values: `USER`, `ASSISTANT`
  - `content` (object, required) — Message content with type discriminator
    - `type`: `PLAIN_TEXT` (PLAIN_TEXT)
      - `plain_text` (object, required)
        - `text` (string, required) — Plain text content
    - `type`: `COMMONMARK_TEXT` (COMMONMARK_TEXT)
      - `commonmark_text` (object, required)
        - `text` (string, required) — Commonmark-formatted text content
    - `type`: `MARKDOWN_TEXT` (MARKDOWN_TEXT)
      - `markdown_text` (object, required)
        - `text` (string, required) — Raw markdown text content. Used when Minerva's chat response `is_commonmark` is not set.
    - `type`: `CALLBACK_ACTION_CONTENT` (CALLBACK_ACTION_CONTENT)
      - `callback_action` (object, required)
        - `callback_id` (string, required) — Opaque callback id for the action the user triggered. Submit this via `input.callback_id` on the create response endpoint to trigger the action.
  - `created_at` (datetime, required) — Creation timestamp (ISO 8601)
  - `citations` (list of object, optional, nullable) — Unique citation references in the assistant message. Use `content_references` to determine where in the message text each citation is referenced.
    - `citation_id` (string, optional) — Unique citation identifier (format: `cite_<base62>`). Use this to join with `content_references` on the Message object.
    - `url` (string, optional) — URL to the entity
    - `display` (object, optional)
      - `title` (object, optional) — Primary heading/identifier with type discriminator
        - `type`: `PLAIN_TEXT` (PLAIN_TEXT)
          - `plain_text` (object, required)
            - `text` (string, required) — Plain text content
        - `type`: `COMMONMARK_TEXT` (COMMONMARK_TEXT)
          - `commonmark_text` (object, required)
            - `text` (string, required) — Commonmark-formatted text content
        - `type`: `MARKDOWN_TEXT` (MARKDOWN_TEXT)
          - `markdown_text` (object, required)
            - `text` (string, required) — Raw markdown text content. Used when Minerva's chat response `is_commonmark` is not set.
        - `type`: `CALLBACK_ACTION_CONTENT` (CALLBACK_ACTION_CONTENT)
          - `callback_action` (object, required)
            - `callback_id` (string, required) — Opaque callback id for the action the user triggered. Submit this via `input.callback_id` on the create response endpoint to trigger the action.
      - `body` (object, optional) — Body/description content with type discriminator
        - `type`: `PLAIN_TEXT` (PLAIN_TEXT)
          - `plain_text` (object, required)
            - `text` (string, required) — Plain text content
        - `type`: `COMMONMARK_TEXT` (COMMONMARK_TEXT)
          - `commonmark_text` (object, required)
            - `text` (string, required) — Commonmark-formatted text content
        - `type`: `MARKDOWN_TEXT` (MARKDOWN_TEXT)
          - `markdown_text` (object, required)
            - `text` (string, required) — Raw markdown text content. Used when Minerva's chat response `is_commonmark` is not set.
        - `type`: `CALLBACK_ACTION_CONTENT` (CALLBACK_ACTION_CONTENT)
          - `callback_action` (object, required)
            - `callback_id` (string, required) — Opaque callback id for the action the user triggered. Submit this via `input.callback_id` on the create response endpoint to trigger the action.
      - `attributes` (list of object, optional) — Opaque key-value metadata for citation display. These attributes contain implementation-specific rendering hints and should be treated as a black-box by clients. The structure and values may vary between citations and should not be relied upon for business logic.
        - `key` (string, required) — Attribute name
        - `value` (string, required) — Attribute value
  - `content_references` (list of object, optional, nullable) — Ordered positions in the message text where citations appear (ascending by offset). Each entry references a `Citation` via `citation_id`. Only populated on assistant messages.
    - `citation_id` (string, required) — References `Citation.citation_id` to link this position to a citation entity.
    - `offset` (integer, required) — Zero-based character position in the assistant message where the citation appears.
  - `feedback` (object, optional, nullable) — Feedback options for this message. Present only on final assistant messages that support feedback. Use the callback IDs to submit a rating via the feedback endpoint.
    - `helpful` (object, optional) — Positive feedback option. Use this callback_id to rate the response as helpful.
      - `callback_id` (string, required) — Opaque callback identifier. Pass this value to the feedback endpoint to submit this rating.
    - `unhelpful` (object, optional) — Negative feedback option. Use this callback_id to rate the response as unhelpful.
      - `callback_id` (string, required) — Opaque callback identifier. Pass this value to the feedback endpoint to submit this rating.
  - `actions` (list of object, optional) — Actions a user can take in response to this message (e.g. buttons or links). Absent on messages with no actions.
    - `type`: `CALLBACK_ACTION` (CALLBACK_ACTION)
      - `callback_action` (object, required)
        - `callback_id` (string, required) — Opaque callback identifier for the action. Submit this via `input.callback_id` on the create response endpoint to trigger the action.
      - `label` (string, required) — Label associated with the action (e.g., button text).
    - `type`: `URL_ACTION` (URL_ACTION)
      - `label` (string, required) — Label associated with the action (e.g., link text).
      - `url_action` (object, required)
        - `url` (string, required) — URL to open when the action is triggered.

## Examples

**Response**

```json
{
  "messages": [
    {
      "message_id": "msg_32bt8vagXAoRwRLIdI2Oj",
      "conversation_id": "conv_32bt7BMLhLyVzTUjfi35N",
      "response_id": "resp_32bt7rXXugeJjvE3pQzOk",
      "actor": "ASSISTANT",
      "content": {
        "type": "COMMONMARK_TEXT",
        "commonmark_text": {
          "text": "John Doe reports to Jane Smith in the Engineering department."
        }
      },
      "created_at": "2025-01-20T10:00:01Z",
      "citations": [
        {
          "citation_id": "cite_32bt9xYZabcDEFghijk",
          "url": "https://company.com/users/123",
          "display": {
            "title": {
              "type": "COMMONMARK_TEXT",
              "commonmark_text": {
                "text": "John Doe"
              }
            },
            "body": {
              "type": "COMMONMARK_TEXT",
              "commonmark_text": {
                "text": "John Doe reports to Jane Smith in the Engineering department."
              }
            },
            "attributes": [
              {
                "key": "EMAIL",
                "value": "johndoe@company.com"
              },
              {
                "key": "MANAGER",
                "value": "Jane Smith"
              }
            ]
          }
        }
      ],
      "content_references": [
        {
          "citation_id": "cite_32bt9xYZabcDEFghijk",
          "offset": 0
        },
        {
          "citation_id": "cite_32bt9xYZabcDEFghijk",
          "offset": 20
        }
      ],
      "feedback": {
        "helpful": {
          "callback_id": "eyJhY3Rpb24iOiJoZWxwZnVsIi4uLn0"
        },
        "unhelpful": {
          "callback_id": "eyJhY3Rpb24iOiJ1bmhlbHBmdWwiLi4ufQ"
        }
      }
    },
    {
      "message_id": "msg_32bt8vagXAoRwRLIdI2Oj",
      "conversation_id": "conv_32bt7BMLhLyVzTUjfi35N",
      "response_id": "resp_32bt7rXXugeJjvE3pQzOk",
      "actor": "USER",
      "content": {
        "type": "PLAIN_TEXT",
        "plain_text": {
          "text": "Who does John Doe report to?"
        }
      },
      "created_at": "2025-01-20T10:00:00Z"
    }
  ]
}
```

**SDK Code**

```python Messages_listResponseMessages_example
import requests

url = "https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages"

headers = {
    "Assistant-Name": "acmecorp-conversations-rest-api",
    "Authorization": "Bearer <token>"
}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Messages_listResponseMessages_example
const url = 'https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages';
const options = {
  method: 'GET',
  headers: {
    'Assistant-Name': 'acmecorp-conversations-rest-api',
    Authorization: 'Bearer <token>'
  }
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Messages_listResponseMessages_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Assistant-Name", "acmecorp-conversations-rest-api")
	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Messages_listResponseMessages_example
require 'uri'
require 'net/http'

url = URI("https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Assistant-Name"] = 'acmecorp-conversations-rest-api'
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Messages_listResponseMessages_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages")
  .header("Assistant-Name", "acmecorp-conversations-rest-api")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Messages_listResponseMessages_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages', [
  'headers' => [
    'Assistant-Name' => 'acmecorp-conversations-rest-api',
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Messages_listResponseMessages_example
using RestSharp;

var client = new RestClient("https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages");
var request = new RestRequest(Method.GET);
request.AddHeader("Assistant-Name", "acmecorp-conversations-rest-api");
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Messages_listResponseMessages_example
import Foundation

let headers = [
  "Assistant-Name": "acmecorp-conversations-rest-api",
  "Authorization": "Bearer <token>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.moveworks.ai/assistant/v1/conversations/conv_32bt7BMLhLyVzTUjfi35N/responses/resp_32bt7rXXugeJjvE3pQzOk/messages")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```